﻿using UnityEngine;
using System.Collections;

public class ScriptJavelin : MonoBehaviour {
	
	public GameObject sangue;
	public GUIText scrittaHUD;
	
	public void AutoAim(GameObject target){
		
		
		
		//gameObject.transform;
		Vector3 targetDir = 
			target.transform.position - 
			transform.position;

		float targetDist = targetDir.magnitude;

		// "walk" the target
		targetDir = 
			target.transform.position + target.gameObject.rigidbody.velocity * (0.5f*targetDist / 10)
			- 
			transform.position;
		
		targetDist = targetDir.magnitude;


		targetDir.Normalize();
		/*targetDir /= targetDir.magnitude;
		targetDir.magnitude = 1.0;*/
		
		
		
		gameObject.rigidbody.velocity = 
			targetDir * 10.0f;
		
		/*
		gameObject.rigidbody.velocity +=
			Vector3.up * 4.0f;
			*/
		
		gameObject.rigidbody.velocity +=
			Vector3.up * (-1.3f*targetDist / Physics.gravity.y ) 
				+ Random.insideUnitSphere*0.8f;
		
		
		transform.rotation = Quaternion.FromToRotation(
				Vector3.up,
				rigidbody.velocity.normalized
			);
		
		FixedUpdate();
	}
	
	// Use this for initialization
	void Start () {
	}
	
	GameObject FindParentPlayer(GameObject gg){
		if (gg.CompareTag("Player")) return gg;
		if (gg.transform.parent==null) return null;
		if (gg.transform.parent.gameObject==null) return null;
		return FindParentPlayer(gg.transform.parent.gameObject);
	}
	
	void OnCollisionEnter(Collision c){
		//Debug.Log ("Hit: " + c.collider.gameObject.name);
		gameObject.collider.enabled = false;
		gameObject.rigidbody.isKinematic = true;
		gameObject.transform.parent = c.collider.transform;
		gameObject.transform.position += gameObject.transform.up * 0.3f;

		GameObject gg = FindParentPlayer( c.gameObject );
		if (gg) {
			scriptOmino s = gg.GetComponent<scriptOmino>();
			s.Die();
			GameObject fiotto = GameObject.Instantiate( sangue, 
				c.contacts[0].point,
				Quaternion.FromToRotation(
				  Vector3.forward,
				  c.contacts[0].normal 
			
				)
			) as GameObject;
			fiotto.transform.parent = c.gameObject.transform;
			Destroy(fiotto, 5.0f);
			Debug.Log("Colpito: "+ c.gameObject.name );
			if (string.Equals( c.gameObject.name , "head") ) scrittaHUD.text = "HEADSHOT!";
			else scrittaHUD.text = "Hit "+c.gameObject.name;
			
		}
			
		if (c.gameObject.rigidbody!= null) {
		  c.gameObject.rigidbody.AddForce( gameObject.rigidbody.velocity * gameObject.rigidbody.mass, ForceMode.Impulse );
		}
		
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if (collider.isTrigger) return; 
		if (rigidbody.velocity.magnitude > 5.0) {
			transform.rotation = Quaternion.FromToRotation(
				Vector3.up,
				rigidbody.velocity.normalized
			);
		}
	}
}
