﻿using UnityEngine;
using System.Collections;


public class ScriptJavelinCannon : MonoBehaviour {

	public GameObject ammo;
	public GameObject target;
	
	public float rateOfFire = 0.20f; 
	
	public GUIText textHUD;
	
	float timeToNextFire = 0.5f;
	
	// Use this for initialization
	void Start () {
		timeToNextFire = Random.Range( 0.0f, 1.0f)/rateOfFire;
	}
	
	void Fire(){
		GameObject newJav = Object.Instantiate(ammo) as GameObject;
		newJav.transform.position = transform.position;
		newJav.GetComponent< ScriptJavelin >().AutoAim( target );
		newJav.GetComponent< ScriptJavelin >().scrittaHUD = textHUD;
	}
	
	void FixedUpdate () {
		timeToNextFire -= Time.deltaTime;
		
		
		if (timeToNextFire<0 ) {
			Fire();
			timeToNextFire = Random.Range( 0.25f, 1.0f)/rateOfFire;
			//textHUD.text = "FIRE!!!";
		}
		else if (timeToNextFire<0.5f) {
			//textHUD.text = "Aim....";
		}
		else if (timeToNextFire<2.5f) {
			//textHUD.text = "";
		}
	
	}
}
